﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApplication209.ViewModel;

namespace WpfApplication209
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void DragSource_DragStart(object sender, Infragistics.DragDrop.DragDropStartEventArgs e)
        {
            StackPanel sp = e.DragSource as StackPanel;
            e.Data = sp.DataContext;
        }

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
             VM vm  =  Application.Current.Resources["vm"] as VM;
             ListBox lbtarget;
             ObservableCollection<Person> targetsource;
             StackPanel ssp;

             ObservableCollection<Person> ssource;
 
             Person sp;
             ListBox lbsource;
             if (e.DropTarget is ListBox)
             {
                 lbtarget = e.DropTarget as ListBox;
                 targetsource = lbtarget.ItemsSource as ObservableCollection<Person>;
                 ssp = e.DragSource as StackPanel;
                 sp = ssp.DataContext as Person;
                 lbsource = Infragistics.Windows.Utilities.GetAncestorFromType(ssp, typeof(ListBox), false) as ListBox;
                 ssource = lbsource.ItemsSource as ObservableCollection<Person>;
                 ssource.Remove(sp);
                 targetsource.Add(sp);

             }
             else
             {

                 StackPanel tsp = e.DropTarget as StackPanel;
                 Person tp = tsp.DataContext as Person;

                 lbtarget = Infragistics.Windows.Utilities.GetAncestorFromType(tsp, typeof(ListBox), false) as ListBox;
                 targetsource = lbtarget.ItemsSource as ObservableCollection<Person>;

                 int index = targetsource.IndexOf(tp);


                 ssp = e.DragSource as StackPanel;
                 sp = ssp.DataContext as Person;
                 lbsource = Infragistics.Windows.Utilities.GetAncestorFromType(ssp, typeof(ListBox), false) as ListBox;
                 ssource = lbsource.ItemsSource as ObservableCollection<Person>;
                 ssource.Remove(sp);
                 targetsource.Insert(index, sp);
             }
                
          

        }

        private void DragSource_DragOver(object sender, Infragistics.DragDrop.DragDropMoveEventArgs e)
        {

        }
    }
}
